// gridSub.cc

/*
 --------------
  ʬϥǥ
 --------------
*/

#include <stdio.h>
#include <time.h>

#include "sub.h"
#include "p_tmp.h"
#include "xaj.h"
#include "ksnet.h"

// 饹 GridSub 

class GridSub : public Sub_system {

protected:
  char objectName[20];
  int objectNo;
  int NumInput, NumOutput;
  int i;

// 1. ¦ü, ¦ü, ֥Ȥκ. 

// ¦ü
protected:
  Relay<double> rp_P, rp_E;   // ߱ȯ(ĤѰ)
  Relay<double>* rp_U;        // ήüή(ήüοѰ)

  // üҤϿ
  void Register_receive_ports(void)
    {
      Register((void*) &rp_P);
      Register((void*) &rp_E);
      for(i = 0; i < NumInput; i++){
	Register((void*) &rp_U[i]);
      }
    }

// ¦ü
protected:
  Relay<double>* sp_O;        // ήüοѰ

  // üҤϿ
  void Register_send_ports(void)
    {
      for(i = 0; i < NumOutput; i++){
	Register((void*) &sp_O[i]);
      }
    }

// ֥
protected:
  Xaj slope;                   // ǥǥ
  Ksnet channel;               // ƻǥǥ

  // ֥ȤϿ
  void Register_components(void)
    {
      Register((void*) &slope);
      Register((void*) &channel);
    }

  // ȿ׻ǤϿ(Ȥʤ)
  void Register_iterators(void){}

// ³
protected:
  void Connect_ports(void)
    {
      Connect(((void*) &rp_P), ((void*) &slope), "Receive", "rp_p", 0);
      Connect(((void*) &rp_E), ((void*) &slope), "Receive", "rp_e", 0);
      Connect(((void*) &slope), "Send", "sp", 0, 
	      ((void*) &channel), "Receive", "rpl", 0);

      for(i = 0; i < NumInput; i++){
	Connect(((void*) &rp_U[i]), ((void*) &channel),
		"Receive", "rpu", i);
      }
      for(i = 0; i < NumOutput; i++){
	Connect(((void*) &channel), "Send", "sp", i, ((void*) &sp_O[i]));
      }
    }

  // ľ̿Ѥδؿ(Ȥʤ)
  void Connect_components(void){}

// ̤ν
public:
  void Set_initial_state(FILE* fp)
    {
      fscanf(fp, "%ld", &current_time);
    }

// ̤¸
public:
  void Save_terminal_state(FILE* fp)
    {
      if (fp != NULL) fprintf(fp, "%ld\n", current_time);
    }

// 3. ؿ, 󥹥ȥ饯, ǥȥ饯. 
public:
  Boolean Init(char* o_name,      // ʬϤΥ֥̾
	       int o_num,         // ʬϤΥֹ֥
	       char* c_name,      // ƻʬ³ե̾
	       int ninput,        // ήüο
	       int nlateral,      // ¦ήο
	       int lateralunit,   // ¦ήñ( or )
	       int nseg,          // ƻʬ
	       int noutput,       // ήüο
	       char* slp_o_name,  // ǤΥ֥̾
	       int slp_o_num,     // ǤΥֹ֥
	       int tStepSlp,      // Ǥνϻֳִ
	       char* net_o_name,  // ƻǤΥ֥̾
	       int net_o_num,     // ƻǤΥֹ֥
	       int tStepNet       // ƻǤνϻֳִ
	       )
    { 
      strcpy(objectName, o_name);
      objectNo = o_num;
      /* NumInput */
      if(ninput <= 0){
	Eprint(__FILE__, __LINE__);
	// GridSub::Init
	// 'NumInput' must be natural number.
	Oprint();
	exit(1);
      }
      NumInput = ninput;

      /* NumOutput */
      if(noutput <= 0){
	Eprint(__FILE__, __LINE__);
	// GridSub::Init
	// 'NumOutput' must be natural number.
	Oprint();
	exit(1);
      }
      NumOutput = noutput;


      /* ¦¦üҤν */
      rp_P.Init("rp_P", 0);
      rp_E.Init("rp_E", 0);
      if((rp_U = new Relay<double>[NumInput]) == NULL){
	Eprint_memory(__FILE__, __LINE__);
	// GridSub :: Init
	// Cannot allocate memory for rp_U.
	Oprint();
	exit(1);
      }
      for(i = 0; i < NumInput; i++){
	rp_U[i].Init("rp_U", i);
      }

      if((sp_O = new Relay<double>[NumOutput]) == NULL){
	Eprint_memory(__FILE__, __LINE__);
	// GridSub :: Init
	// Cannot allocate memory for sp_O.
	Oprint();
	exit(1);
      }
      for(i = 0; i < NumOutput; i++){
	sp_O[i].Init("sp_O", i);
      }

      // ̥֥Ȥν
      slope.Init(slp_o_name,      // ֥̾
		 slp_o_num,       // ֹ֥
		 tStepSlp         // ϻֳִ
		 );

      // ƻ֥֥Ȥν
      channel.Init(net_o_name,    // ֥̾
		   net_o_num,     // ֹ֥
		   c_name,        // ƻʬ³ե̾
		   ninput,        // ήü
		   nlateral,      // ¦ή
		   lateralunit,   // ¦ήñ
		   nseg,          // ƻʬ
		   noutput,       // ήü
		   tStepNet       // ϻֳִ
		   );

      return Sub_system :: Init(o_name, o_num, 0, NULL); 
    }

  GridSub(char* o_name,           // ʬϤΥ֥̾
	  int o_num,              // ʬϤΥֹ֥
	  char* c_name,           // ƻʬ³ե̾
	  int ninput,             // ήüο
	  int nlateral,           // ¦ήο
	  int lateralunit,        // ¦ήñ( or )
	  int nseg,               // ƻʬ
	  int noutput,            // ήüο
	  char* slp_o_name,       // ǤΥ֥̾
	  int slp_o_num,          // ǤΥֹ֥
	  int tStepSlp,           // Ǥνϻֳִ
	  char* net_o_name,       // ƻǤΥ֥̾
	  int net_o_num,          // ƻǤΥֹ֥
	  int tStepNet            // ƻǤνϻֳִ
	  )
    :  Sub_system()
      {
	class_name = "GridSub";
	Init(o_name, o_num, c_name, ninput, nlateral, lateralunit,
	     nseg, noutput, slp_o_name, slp_o_num, tStepSlp,
	     net_o_name, net_o_num, tStepNet);
      }

  GridSub(void)
    :  Sub_system()
      { class_name = "GridSub"; }

  ~GridSub(void){
    delete [] rp_U;
    delete [] sp_O;
  }

  Boolean Work(void)
    {
      //		Sub_system::Work(void) (define)
      
      if (current_time >= Terminal_time()) return NO;		// ׻Ѥ. 

      printf("**** Now computing '%s', %d ****\n", objectName, objectNo);

      int i, j, k;
      Boolean calc = NO, flag_all, flag_itr;
      // calc	  : ؿƤФư٤Ǥ׻ɤ
      // flag_all : (ȿ׻Ǥޤ)ĤǤ׻ YES
      // flag_itr : ȿ׻ǤĤǤ׻ YES
      
      int* itrcounter = new int[number_of_iterator_sets];
      for (i = 0; i < number_of_iterator_sets; i++) itrcounter[i] = 0;
      
      // Ǥη׻. 
      do {
	flag_all = NO;
	
	// component_array
	for (k = 0; k < number_of_components; k++) {
	  if (((Element*) component_array[k])->Work() == YES)
	    { calc = flag_all = YES; break; }
	}
	while (++k < number_of_components)
	  ((Element*) component_array[k])->Work();
	
	// iterator_array
	for (i = 0; i < number_of_iterator_sets; i++) {
	  do {
	    flag_itr = NO;
	    for (j = 0; j < number_of_iterators[i]; j++) {
	      if (((Element*) iterator_array[i][j])->
		  Work() == YES) {
		calc = flag_all = flag_itr = YES;
		break;
	      }
	    }
	    while (++j < number_of_iterators[i])
	      ((Element*) iterator_array[i][j])->Work();
	    
	  } while (flag_itr == YES);
	  
	  // i Ǥȿ׻ɸãƤ뤫
	  if (Do_you_reach_target_time(i) == YES) {
	    // «Ƥ뤫
	    if (Do_you_converge(i) == YES) {
	      // ޤäǡϤ
	      Flush_data(i);
	      // fixed_time 򹹿
	      Renew_fixed_time(i);
	      // ȿ׻ɸꤵ
	      Renew_target_time(i, Calculate_iteration_step(i));
	      // itrcounter  0 ᤹
	      itrcounter[i] = 0;
	    }
	    else {
	      // current_time 򴬤᤹
	      Rewind_current_time(i);
	      // itrcounter  1 䤹
	      if (++itrcounter[i] >= 1000) {
		Eprint(__FILE__, __LINE__);
		// Sub_system::Work(void)
		// Iterative calculation cannot converge
		fprintf(stderr, "tin group [%d].\n", i);
		Oprint(); exit(1);
	      }
	    }
	  }
	}
      } while (flag_all == YES);
      
      // ׻Ǥʤä. 	
      if (calc == NO) {
	delete [] itrcounter;
	return NO;
      }
      
      // current_time ι. 
      if (Renew_current_time() != YES)
	{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
      // Sub_system::Work(void)
      
      // ׻. 	
      delete [] itrcounter;

      return YES;
    }

};


