/* ksnet.h
----------------------------------------------------------------------------
  Kw_for_strnet : ƻֽ淿 kinematic wave ǥ (Multi-output б)
----------------------------------------------------------------------------
*/

#if !defined(_ksnet_h)
#define _ksnet_h

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#include "common.h"                                 /* ̴Ķ */
#include "list.h"                               /* 饹 List  */
#include "element.h"                         /* 饹 Element  */
#include "p_tmp.h"         /* ƥץ졼ȥ饹 Receive, Send  */


class Ksnet : public Element {

  /* ü */
 protected:
  Receive<double>* rpu;
  Receive<double>* rpl;
 protected:
  void Register_receive_ports(void);
  
  /* ü */
 protected:
  Send<double>* sp;
  void Register_send_ports(void);
  
  /* ѥ᥿ */
 protected:
  int ninput;                       /* ήβƻ֤ήƻʬ */
  int nlateral;                                           /* ¦ήο */
  int lateral_unit;  /* ¦ήñ̤ξ, 2(m^2/sec) 3(m^3/sec) */
  int nsegment;			                          /* ƻʬο */
  int noutput;                        /* ήβƻ֤ήФƻʬ */
  int tStep;                                              /* ϻֳִ */
  // ϥ󥹥ȥ饯ΰȤͿ.
    
  double* L;                                                  /* Ĺ */
  double* B;                                                  /* ƻ */
  double* G;                                                /* Ͼ */
  double* K;                                          /* kinematic  */
  double* P;                                          /* kinematic  */
  double sum_length;                              /* ƲƻʬĹι */
  double area;                                      /* ƻ */
  double* alpha;                                           /* ήʬΨ*/
	
  int* seg_NO;                                    /* ºݤβƻʬֹ */
  int* sigma_up;                    /* ήüܤƤƻʬ */
  int** mu_up;                  /* ήüܤƤƻʬ³ */
  int* sigma_down;                  /* ήüܤƤƻʬ */
  int** mu_down;                /* ήüܤƤƻʬ³ */
  int* cal_order;                                     /* ׻ξ */

  int* rpu_NO;            /* üҤΥֹ֥Ȳƻʬξ 
                             㤨Сrpu_NO[i] = n ΤȤ
			     ֹ֥ i μüҤȲβƻʬ
			     ֹ n-1 βƻʬҤäƤ뤳Ȥ򼨤*/

  int* sp_NO;             /* üҤΥֹ֥Ȳƻʬξ 
			     㤨Сsp_NO[i] = n ΤȤ
			     ֹ֥ i üҤȲβƻʬ
			     ֹ n-1 βƻʬҤäƤ뤳Ȥ򼨤*/


  /*  */
  double sum_input_next;    /* 줫׻Ǥξήüή */
  double sum_input_current;        /* current_time Ǥξήüή */

  double lateral_next_time;         /* 줫׻Ǥ¦ή */
  double lateral_current_time;             /* current_time Ǥ¦ή */

  double q0;                                              /* ήѲΨ */
	
  double* Q_up;                       /* ƲƻʬκǾήüǤή̤
					       ǼؤΥݥ */
  double* Q_down;                     /* ƲƻʬκǲήǤή̤
     				               ǼؤΥݥ */
	
  double storage_current_time;                                /* α */

  double sum_output_next;   /* 줫׻Ǥβήüή */     
  double sum_output_current;       /* current_time Ǥβήüή */

  /* ؿ󥹥ȥ饯ǥȥ饯 */
 public:
  Boolean Init(char* o_name, int o_num, char* p_str,
	       int numinput, int numlateral, int lateral_unit_tmp,
	       int numsegment, int numoutput, int t_step);
  
  Ksnet(char* o_name, int o_num, char* p_str,
	int numinput, int numlateral, int lateral_unit_tmp, 
	int numsegment, int numoutput, int t_step);
           // class_name  "Ksnet" ꤷobject_name 
           // o_name ˡϿ numinput ˡ¦ή
           // numlateral ˡ¦ή̤ñ̤ lateral_unit_tmp 
           // ƻʬ numsegment ˡ
	   // Ͽ numoutput ꤹ롣
	     
  Ksnet(void);

  ~Ksnet(void);
          // L, B, K, P, alpha, seg_NO, sigma_up, mu_up, sigma_down, mu_down,
          // Q_up, Q_down, rpu, rpl, sp õ롣

  /* ѥ᥿ꡦ̤ν */
 public:
  void Set_parameter(FILE* fp);
        // kinematic  KP ȶĹ L ƻ B ήʬΨ alpha 
        // ꤷ nsegment ĤǤ Q_up  Q_down 
        // Ѱդ롣
	//  
	//-------------------------------
	// ѥ᥿ѥեν
	// ------------------------------
	//  
	// ͿڤӤν񼰤ϼ̤ꡣ
	//  
	// num L B grad manning P
	//   num -> ºݤβƻʬֹ
	//     L -> ƻʬĹ
	//     B -> ƻʬ
	//     P -> kinematic 
	//          A(̿) = K * pow(Q(ή), P)
	//     K = pow(B, 1 - P)
	//               * pow((sqrt(grad) / manning), - P)
	//
	// ()
	// 25 240.6 30.1 0.002 0.3 0.6
	// 13 190.2 23.6 0.001 0.3 0.6
	// 72 146.3 24.8 0.003 0.3 0.6
	// ...

  void Set_initial_state(FILE* fp);
	// ή Q_out ꤹ
	//
	//--------------------------------  
	// ѥեν
	//--------------------------------
	//  
	//  : ׻ϻ
	//  : ǾήüǤή(üҤΥֹ֥
        //          㤤 ninput )
	//  : ¦ή(Ʊnlateral )
	//  : ǲήüǤή(üҤΥֹ֥
        //          㤤 noutput )
	// ή̤ñ̤Ϥ٤ m^3/sec

	// ()
	// 0
	// 0.0 1.3 0.5
	// 3.1 0.1 0.6 0.7
	// 0.9 0.3 0.8

  void Save_terminal_state(FILE* fp);
	// ǽ֤ե˽Ϥ

 protected:
  void Sub_connect(char* cf_name);
		/*
		 Ksnet::Sub_connect  ήƻʬ
			ե̾ cf_name Υե뤫ήƻʬ
			ؤƻʬֹդؤ³
			ꡦ׻ηԤ

			---------------------------------------
			Sub_connect Ϳեν
			---------------------------------------
			狼Ť餤Τǡ򤢤
			)
                            \    /            Ʋƻʬ˰դ
		           13\  /47           ֹ()Ĥ롣 
			      \/              
			       \              ϼºݤβƻʬ
                              21\             ֹǤ롣
                                 \            
			         /\           ޤ 13,47 ϲƻ֤ξήü
			     102/  \59        102,59 ϲήüǤ롣 
                               /    \        

			---<from here>---
			# file for infomation of sub_connect
			# 
			# ͿڤӤν񼰤ϼ̤ꡣ
			# 
			# num1 : num2 : a1 a2 a3 ... : num3 : b1 b2 b3 ... 
			#
			#     num1      -> ºݤβƻʬֹ
			#
			#     num2      -> ήüܤƤƻʬο
			#
			#  a1,a2,a3,... -> (num2 > 0 λ)
			#                  ήüܤƤƻʬ
                        #                  ֹ(ήƤƻʬ
                        #                  ΤޤޡήФƤƻʬ
                        #                  դ num2 ¤٤)
			#
			#                  (num2 = 0 λ)
			#                  ήüˤüҤ
			#                  ֹ֥(a1)
			#
                        #     num3      -> ήüܤƤƻʬο
			#                  
                        #  b1,b2,b3,... -> (num3 > 0 λ)
			#                  ήüܤƤƻʬ
			#                  ֹ(ήФƤƻʬ
			#                  ΤޤޡήƤƻʬ
			#                  դ num3 ¤٤)
			#
			#                  (num3 = 0 λ)
			#                  ήüˤüҤ
			#                  ֹ֥(b1)
			#
			# Ƭ '#' ΤԤԤ̵뤵

			102 : 2 : 21 -59  : 0 : 0 (sp)
			47  : 0 : 1 (rpu) : 2 : 21 -13
			59  : 2 : 21 -102 : 0 : 1 (sp)
			13  : 0 : 0 (rpu) : 2 : 21 -47
			21  : 2 : 13  47  : 2 : 102 59

			# Υե뤫ƻʬֹդؤԤ
			# ʲΤ褦ʾ롣
			# ֹդؤΥ롼
			#    Sub_connectեΣιܤ˵줿ƻ
			#    ƻʬֹ򡢣(βƻʬֹ)Ȥ롣
			#    59֤βƻʬϲβƻʬֹ3
			#    ġ

			1 : 2 : 5 -3    : 0 : 0 (sp)
			2 : 0 : 1 (rpu) : 2 : 5 -4
			3 : 2 : 5 -1    : 0 : 1 (sp)
			4 : 0 : 0 (rpu) : 2 : 5 -2
			5 : 2 : 4 2     : 2 : 1 3

			# ׻Ϥξ(βƻʬֹ)Ȥ˹Ԥ

			---<to here>---
		*/

 protected:
  double Storage_by_continuity(double q0_tmp);
	// Ϣ³ǺʬŸα̤׻

  double Storage_by_integral(double q0_tmp);
	// Ʋƻ̤̿ѤʬƲƻα̤
	// ׻

 public:
  Boolean Initial_output(void);
  time_t Calculate_time_step(void){ return (time_t)tStep; }
  Boolean Can_you_calculate(void) { return Can_you_calculate0(); }
//	Boolean Can_you_calculate(void) { return YES; }
  Boolean Calculate(void);
  Boolean Work(void) { return Work0(); }

};

#endif
