/* xaj.cc
--------------------------------------------
饹 Xaj μ¸
--------------------------------------------
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#include "common.h"           /* ̴Ķ */
#include "list.h"             /* 饹 List  */
#include "element.h"          /* 饹 Element  */
#include "p_tmp.h"            /* ƥץ졼ȥ饹 Receive, Send  */
#include "xaj.h"              /* 饹 Xaj  */

// ؿ
Boolean Xaj :: Init(char* o_name, int o_num, int ISEC_tmp)
{
  /* ISEC */
  if (ISEC_tmp <= 0){
    Eprint(__FILE__, __LINE__);
    // Xaj::Init
    // 'ISEC' must be a natural number.
    Oprint();
    exit(1);
  }

  if (ISEC_tmp > 3600){
    Eprint(__FILE__, __LINE__);
    // Xaj::Init
    // 'ISEC' should not be greater than 3600 (1 hr).
    Oprint();
    exit(1);
  }

  ISEC = ISEC_tmp;

  /* üҡüҤν */
  rp_p.Init("rp_p", 0);
  rp_e.Init("rp_e", 0);
  sp.Init("sp", 0);

  return Element :: Init(o_name, o_num, 0, NULL);
}

// դ󥹥ȥ饯
Xaj :: Xaj(char* o_name, int o_num, int ISEC_tmp) : Element()
{
  class_name = "Xaj";
  Init(o_name, o_num, ISEC_tmp);
}

// ǥեȥ󥹥ȥ饯
Xaj :: Xaj(void) : Element()
{
  class_name = "Xaj";
}

// üҤϿ
void Xaj :: Register_receive_ports(void)
{
  Register((void*) &rp_p);
  Register((void*) &rp_e);
}

// üҤϿ
void Xaj :: Register_send_ports(void)
{
  Register((void*) &sp);
}

// ѥ᥿
void Xaj :: Set_parameter(FILE* fp)
{
  double Ai_tmp, b_tmp, Wm_tmp, kg_tmp, c_area_tmp;

  if(fscanf(fp, "%lf %lf %lf %lf %lf",
	    &Ai_tmp, &b_tmp, &Wm_tmp, &kg_tmp, &c_area_tmp) != 5){
    Eprint(__FILE__, __LINE__);
    // Xaj::Set_parameter
    // Cannot scan information of parameter.
    Oprint();
    exit(1);
  }

  if((Ai_tmp < 0.) || (Ai_tmp > 1.) || (b_tmp <= 0.) || (Wm_tmp < 0.)
     || (kg_tmp < 0.) || (kg_tmp > 1.) || (c_area_tmp < 0.)){
    Eprint(__FILE__, __LINE__);
    // Xaj::Set_parameter
    // Invalid parameter are given.
    Oprint();
    exit(1);
  }

  Ai = Ai_tmp;
  b = b_tmp;
  Wm = Wm_tmp;
  kg = kg_tmp;
  c_area = c_area_tmp;

  /* Im η׻ */
  Im = Wm * (1. + b) / (1. - Ai);
//  printf("Im = %lf\n", Im);
}

// ֤
void Xaj :: Set_initial_state(FILE* fp)
{
  time_t tnow;
  double I_tmp, storage_tmp;

  if(fscanf(fp, "%d %lf %lf", &tnow, &I_tmp, &storage_tmp) != 3){
    Eprint(__FILE__, __LINE__);
    // Xaj::Set_initial_state
    // Cannot initialize.
    Oprint();
    exit(1);
  }

  if(I_tmp < 0.){
    Eprint(__FILE__, __LINE__);
    // Xaj::Set_initial_state
    // 'I' should not have a negative value.
    Oprint();
    exit(1);
  }
    
  if(I_tmp > Im){
    Eprint(__FILE__, __LINE__);
    // Xaj::Set_initial_state
    // 'I' should not be greater than 'Im'.
    Oprint();
    exit(1);
  }

  if(storage_tmp < 0.){
    Eprint(__FILE__, __LINE__);
    // Xaj::Set_initial_state
    // 'storage' should not have a negative value.
    Oprint();
    exit(1);
  }

  current_time = tnow;
  I = I_tmp;
  storage = storage_tmp;
  storage_init = storage;

  /* W η׻ */
  W = Wm * (1. - pow(1. - I/Im , 1. + b));
  W_init = W;

  /* Q_sum, sum_total, P_effec_sum  */
  Q_sum = 0.;
  sum_total = 0;
  P_effec_sum = 0.;

}

// ǽ֤¸
void Xaj :: Save_terminal_state(FILE* fp)
{
  if(fp == NULL){
    Eprint(__FILE__, __LINE__);
    // Xaj::Save_terminal_state
    // Cannot save terminal state.
    Oprint();
    exit(1);
  }
  fprintf(fp, "%d %lf %lf", current_time, I, storage);
}

// 
Boolean Xaj :: Initial_output(void)
{
  T = current_time;
  discharge = 0.0;
  sp.Send_data(T, discharge);
  return YES;
}

// ήз׻
Boolean Xaj :: Calculate(void)
{
  P = rp_p.Get_data(current_time + time_step);  // P : mm/hour
  E = rp_e.Get_data(current_time + time_step);  // E : mm/hour
  P_effec = (P - E) * 1/3600 * ISEC;    // P_effec ñ : mm/ISEC

  if(P_effec > 0.) Qi = Ai * P_effec;    // Qi ñ : mm/ISEC
  else Qi = 0.;
  // Qi ñ̻ľήй(mm/ñ̻)

  double Q_temp = 0.;
  double Qp_sum = 0.;
  double W_temp = 0.;  // Ϣ³طĴ٤뤿ѿ

  for(int i = 0; i < 3600/ISEC; i++){
    if(P_effec < 0.){
      Qp = 0.;

      W_temp = W;
      W -= fabs(P_effec);
      if(W < 0.){
	W = 0.;
	P_effec_sum -= W_temp;
      }
      else P_effec_sum += P_effec;

      I = Im * (1. - pow(1.-(W/Wm), 1./(1.+b)));
    }

    else{
      if(I + P_effec >= Im){
	Qp = P_effec * (1. - Ai) - Wm + W;
      }
      else{
	Qp = P_effec * (1. - Ai) - Wm + W
	  + Wm * pow(1. - (I + P_effec)/Im , 1. + b);
      }
      P_effec_sum += P_effec;
    }
                                          // Qp ñ : mm/ISEC
    storage += Qp;
    Qp_sum += Qp;

    double q;
    q = kg * pow(storage, 2);         // q ñ : mm/ISEC 

    if(q * ISEC/3600 <= storage) Qs = q * ISEC/3600;  // Qs ñ : mm/ISEC
    else Qs = storage;

    Q = Qi + Qs;
    Q_sum += Q;
    Q_temp += Q;

    /* ήФ m^3/sec ǽ */
/*
    T = current_time + (i*2 + 1)*ISEC/2;
    discharge = (Q/1000)/ISEC * c_area * pow(10,6); 
    // ήФ m^3/sec ľ.

    sp.Send_data(T, discharge);
*/
    /* ̤ι */
    storage -= Qs;

    if(P_effec > 0.){
      if(I + P_effec <= Im) I += P_effec;
      else I = Im;
    
      W = Wm * (1. - pow(1. - I/Im , 1. + b));
    }
  }

  double checker;
  sum_total = Q_sum + storage + W;
  checker = sum_total - P_effec_sum - storage_init - W_init;

//  printf("checker = %lf\n", checker);

  if(fabs(checker) >= 0.000001){
    printf("Ϣ³طƤޤ.\n");
    exit(1);
  }

  /* ʬήФʿѤ, m^3/sec ǽ */

//  T = current_time + 86400/2;          // ߥ졼˻Ȥ
  T = current_time + 3600;              // ѥ᥿Ʊ˻Ȥ
  discharge = (Q_temp/1000)/(60*60) * c_area * pow(10, 6);

  sp.Send_data(T, discharge);

//  printf("P_effec_sum = %lf sum_total = %lf\n", P_effec_sum, sum_total);

  return YES;
}
