/* xaj.cc
--------------------------------------------
饹 Xaj μ¸ 

ϤܤƽϤ롣ñ㲽¹
ǥ Calculate Τ߰ۤʤ롣SiBUC ˤä
׻줿ή̤ϤȤƲƻ׻Ԥ
, ϤñܤƽϤ롣
--------------------------------------------
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#include "common.h"           /* ̴Ķ */
#include "list.h"             /* 饹 List  */
#include "element.h"          /* 饹 Element  */
#include "p_tmp.h"            /* ƥץ졼ȥ饹 Receive, Send  */
#include "xaj.h"              /* 饹 Xaj  */

// ؿ
Boolean Xaj :: Init(char* o_name, int o_num, int ISEC_tmp)
{
  /* ISEC */
  if (ISEC_tmp <= 0){
    Eprint(__FILE__, __LINE__);
    // Xaj::Init
    // 'ISEC' must be a natural number.
    Oprint();
    exit(1);
  }

  if (ISEC_tmp > 3600){
    Eprint(__FILE__, __LINE__);
    // Xaj::Init
    // 'ISEC' should not be greater than 3600 (1 hr).
    Oprint();
    exit(1);
  }

  ISEC = ISEC_tmp;

  /* üҡüҤν */
  rp_p.Init("rp_p", 0);
  rp_e.Init("rp_e", 0);
  sp.Init("sp", 0);

  return Element :: Init(o_name, o_num, 0, NULL);
}

// դ󥹥ȥ饯
Xaj :: Xaj(char* o_name, int o_num, int ISEC_tmp) : Element()
{
  class_name = "Xaj";
  Init(o_name, o_num, ISEC_tmp);
}

// ǥեȥ󥹥ȥ饯
Xaj :: Xaj(void) : Element()
{
  class_name = "Xaj";
}

// üҤϿ
void Xaj :: Register_receive_ports(void)
{
  Register((void*) &rp_p);
  Register((void*) &rp_e);
}

// üҤϿ
void Xaj :: Register_send_ports(void)
{
  Register((void*) &sp);
}

// ѥ᥿
void Xaj :: Set_parameter(FILE* fp)
{
  double Ai_tmp, b_tmp, Wm_tmp, kg_tmp, c_area_tmp;

  if(fscanf(fp, "%lf %lf %lf %lf %lf",
	    &Ai_tmp, &b_tmp, &Wm_tmp, &kg_tmp, &c_area_tmp) != 5){
    Eprint(__FILE__, __LINE__);
    // Xaj::Set_parameter
    // Cannot scan information of parameter.
    Oprint();
    exit(1);
  }

  if((Ai_tmp < 0.) || (Ai_tmp > 1.) || (b_tmp <= 0.) || (Wm_tmp < 0.)
     || (kg_tmp < 0.) || (kg_tmp > 1.) || (c_area_tmp < 0.)){
    Eprint(__FILE__, __LINE__);
    // Xaj::Set_parameter
    // Invalid parameter are given.
    Oprint();
    exit(1);
  }

  Ai = Ai_tmp;
  b = b_tmp;
  Wm = Wm_tmp;
  kg = kg_tmp;
  c_area = c_area_tmp;

  /* Im η׻ */
  Im = Wm * (1. + b) / (1. - Ai);
//  printf("Im = %lf\n", Im);
}

// ֤
void Xaj :: Set_initial_state(FILE* fp)
{
  time_t tnow;
  double I_tmp, storage_tmp;

  if(fscanf(fp, "%d %lf %lf", &tnow, &I_tmp, &storage_tmp) != 3){
    Eprint(__FILE__, __LINE__);
    // Xaj::Set_initial_state
    // Cannot initialize.
    Oprint();
    exit(1);
  }

  if(I_tmp < 0.){
    Eprint(__FILE__, __LINE__);
    // Xaj::Set_initial_state
    // 'I' should not have a negative value.
    Oprint();
    exit(1);
  }
    
  if(I_tmp > Im){
    Eprint(__FILE__, __LINE__);
    // Xaj::Set_initial_state
    // 'I' should not be greater than 'Im'.
    Oprint();
    exit(1);
  }

  if(storage_tmp < 0.){
    Eprint(__FILE__, __LINE__);
    // Xaj::Set_initial_state
    // 'storage' should not have a negative value.
    Oprint();
    exit(1);
  }

  current_time = tnow;
  I = I_tmp;
  storage = storage_tmp;
  storage_init = storage;

  /* W η׻ */
  W = Wm * (1. - pow(1. - I/Im , 1. + b));
  W_init = W;

  /* Q_sum, sum_total, P_effec_sum  */
  Q_sum = 0.;
  sum_total = 0;
  P_effec_sum = 0.;

}

// ǽ֤¸
void Xaj :: Save_terminal_state(FILE* fp)
{
  if(fp == NULL){
    Eprint(__FILE__, __LINE__);
    // Xaj::Save_terminal_state
    // Cannot save terminal state.
    Oprint();
    exit(1);
  }
  fprintf(fp, "%d %lf %lf", current_time, I, storage);
}

// 
Boolean Xaj :: Initial_output(void)
{  
  Q = rp_p.Get_data(current_time);  // Q : mm/hour
  /* ήФ m^3/sec ǽ */
  discharge = (Q/1000)/(60*60) * c_area * pow(10, 6);
  sp.Send_data(current_time, discharge);
  return YES;
}

// ήз׻
Boolean Xaj :: Calculate(void)
{
  Q = rp_p.Get_data(current_time + time_step);  // Q : mm/hour
  /* ήФ m^3/sec ǽ */
  discharge = (Q/1000)/(60*60) * c_area * pow(10, 6);
  sp.Send_data(current_time + time_step, discharge);
  return YES;
}
